## open-roms 0.0~git20210824.e4e324c

=== Makefile ===

# Test files

TESTDISK = testsuite/testdisk.d64
TESTTAPE = testsuite/testtape-c64-pal-turbo.tap

# Source files

SRCDIR_COMMON  = src/aliases

SRCDIR_BASIC   = $(SRCDIR_COMMON) \
                 src/basic \
                 src/basic/,stubs \
                 src/basic/,stubs_math \
                 src/basic/assets \
                 src/basic/basic_commands \
                 src/basic/basic_commands_01 \
                 src/basic/basic_commands_04 \
                 src/basic/basic_operators \
                 src/basic/basic_functions \
                 src/basic/basic_functions_06 \
                 src/basic/board_crt \
                 src/basic/board_m65 \
                 src/basic/board_u64 \
                 src/basic/board_x16 \
                 src/basic/engine_editor \
                 src/basic/engine_runtime \
                 src/basic/engine_variables \
                 src/basic/init \
                 src/basic/math \
                 src/basic/math_consts \
                 src/basic/math_mov \
                 src/basic/memory \
                 src/basic/print \
                 src/basic/rom_revision \
                 src/basic/wedge

SRCDIR_KERNAL  = $(SRCDIR_COMMON) \
                 src/kernal \
                 src/kernal/,stubs \
                 src/kernal/assets \
                 src/kernal/board_crt \
                 src/kernal/board_m65 \
                 src/kernal/board_u64 \
                 src/kernal/board_x16 \
                 src/kernal/iec \
                 src/kernal/iec_fast \
                 src/kernal/init \
                 src/kernal/interrupts \
                 src/kernal/iostack \
                 src/kernal/jumptable \
                 src/kernal/jumptable_m65 \
                 src/kernal/keyboard \
                 src/kernal/keyboard_m65 \
                 src/kernal/memory \
                 src/kernal/print \
                 src/kernal/rom_revision \
                 src/kernal/rs232 \
                 src/kernal/screen \
                 src/kernal/screen_m65 \
                 src/kernal/tape \
                 src/kernal/time

SRCDIR_DOS_M65 = $(SRCDIR_COMMON) \
                 src/dos_m65 \
                 src/dos_m65/assets \
                 src/dos_m65/filesystem_cbm \
                 src/dos_m65/filesystem_vfs \
                 src/dos_m65/lowlevel \
                 src/dos_m65/pseudoiec \
                 src/dos_m65/unit_card \
                 src/dos_m65/unit_disk \
                 src/dos_m65/unit_ramdisk \
                 src/dos_m65/utils

SRCDIR_MON_M65 = $(SRCDIR_COMMON) \
                 src/mon_m65

SRCDIR_ZVM_M65 = $(SRCDIR_COMMON) \
                 src/zvm_m65

SRC_BASIC      = $(foreach dir,$(SRCDIR_BASIC),$(wildcard $(dir)/*.s))
SRC_KERNAL     = $(foreach dir,$(SRCDIR_KERNAL),$(wildcard $(dir)/*.s))
SRC_DOS_M65    = $(foreach dir,$(SRCDIR_DOS_M65),$(wildcard $(dir)/*.s))
SRC_MON_M65    = $(foreach dir,$(SRCDIR_MON_M65),$(wildcard $(dir)/*.s))
SRC_ZVM_M65    = $(foreach dir,$(SRCDIR_ZVM_M65),$(wildcard $(dir)/*.s))
SRC_TOOLS      = $(wildcard tools/*.c,tools/*.cc)

DIR_ACME       = 3rdparty/acme/src
HDR_ACME       = $(filter-out $(wildcard $(DIR_ACME)/_*.h),$(wildcard $(DIR_ACME)/*.h))
SRC_ACME       = $(DIR_ACME)/acme.c $(DIR_ACME)/platform.c $(DIR_ACME)/alu.c $(DIR_ACME)/typesystem.c \
                 $(DIR_ACME)/cliargs.c $(DIR_ACME)/global.c $(DIR_ACME)/output.c $(DIR_ACME)/flow.c \
                 $(DIR_ACME)/macro.c $(DIR_ACME)/cpu.c $(DIR_ACME)/encoding.c $(DIR_ACME)/pseudoopcodes.c \
                 $(DIR_ACME)/dynabuf.c $(DIR_ACME)/mnemo.c $(DIR_ACME)/input.c $(DIR_ACME)/section.c \
                 $(DIR_ACME)/symbol.c $(DIR_ACME)/tree.c

CRT_BIN_LIST   = assets/cartridge/header-cart.bin \
                 assets/cartridge/header-seg0.bin \
                 assets/cartridge/header-seg1.bin \
                 assets/cartridge/header-seg2.bin \
                 assets/cartridge/header-seg3.bin

ROM_CBM_BASIC  = 3rdparty/ROMs/basic
ROM_CBM_KERNAL = 3rdparty/ROMs/kernal

# Generated files

GEN_BASIC      = build/,generated/,float_constants.s
GEN_KERNAL     =
GEN_ZVM        = build/,generated/,z80_tables.s

# Z80 part

DIR_ZMAC       = 3rdparty/zmac/src
DIR_ZMAC_TMP   = build/,tmp_zmac
HDR_ZMAC       = $(filter-out $(wildcard $(DIR_ZMAC)/_*.h),$(wildcard $(DIR_ZMAC)/*.h))
SRC_ZMAC       = $(DIR_ZMAC)/mio.c $(DIR_ZMAC)/doc.c $(DIR_ZMAC)/zi80dis.cpp
SRC_Z80TEST    = 3rdparty/z80exer/cpm/zexdoc.src

GEN_ZMAC_C     = $(DIR_ZMAC_TMP)/zmac.c
GEN_ZMAC_H     = $(DIR_ZMAC_TMP)/doc.inl

# List of build directories

DIR_CUS        = build/target_custom
DIR_GEN        = build/target_generic
DIR_GENCRT     = build/target_generic_crt
DIR_TST        = build/target_testing
DIR_M65        = build/target_mega65
DIR_U64        = build/target_ultimate64
DIR_U64CRT     = build/target_ultimate64_crt
DIR_X16        = build/target_cx16

# List of config files

CFG_CUS        = src/,,config_custom.s 
CFG_GEN        = src/,,config_generic.s
CFG_GENCRT     = src/,,config_generic_crt.s
CFG_TST        = src/,,config_testing.s
CFG_M65        = src/,,config_mega65.s
CFG_U64        = src/,,config_ultimate64.s
CFG_X16        = src/,,config_cx16.s
CFG_U64CRT     = src/,,config_ultimate64_crt.s

# List of files with generated strings

GEN_STR_CUS    = $(DIR_CUS)/,generated/,packed_strings.s
GEN_STR_GEN    = $(DIR_GEN)/,generated/,packed_strings.s
GEN_STR_GENCRT = $(DIR_GENCRT)/,generated/,packed_strings.s
GEN_STR_TST    = $(DIR_TST)/,generated/,packed_strings.s
GEN_STR_M65    = $(DIR_M65)/,generated/,packed_strings.s
GEN_STR_U64    = $(DIR_U64)/,generated/,packed_strings.s
GEN_STR_U64CRT = $(DIR_U64CRT)/,generated/,packed_strings.s
GEN_STR_X16    = $(DIR_X16)/,generated/,packed_strings.s

# Dependencies - helper variables

DEP_BASIC      = $(SRC_BASIC)   $(SRCDIR_BASIC)   $(GEN_BASIC)
DEP_KERNAL     = $(SRC_KERNAL)  $(SRCDIR_KERNAL)  $(GEN_KERNAL)
DEP_DOS_M65    = $(SRC_DOS_M65) $(SRCDIR_DOS_M65)
DEP_MON_M65    = $(SRC_MON_M65) $(SRCDIR_MON_M65)
DEP_ZVM_M65    = $(SRC_ZVM_M65) $(SRCDIR_ZVM_M65) $(GEN_ZVM)

# List of tools

TOOL_GENERATE_CONSTANTS  = build/tools/generate_constants
TOOL_GENERATE_STRINGS    = build/tools/generate_strings
TOOL_GENERATE_Z80_TABLES = build/tools/generate_z80_tables
TOOL_PATCH_CHARGEN       = build/tools/patch_chargen
TOOL_PNGPREPARE          = build/tools/pngprepare
TOOL_BUILD_SEGMENT       = build/tools/build_segment
TOOL_RELEASE             = build/tools/release
TOOL_SIMILARITY          = build/tools/similarity
TOOL_ASSEMBLER           = build/tools/acme
TOOL_ASSEMBLER_Z80       = build/tools/zmac

TOOLS_LIST = $(TOOL_GENERATE_CONSTANTS) \
             $(TOOL_GENERATE_STRINGS) \
             $(TOOL_GENERATE_Z80_TABLES) \
             $(TOOL_PATCH_CHARGEN) \
             $(TOOL_PNGPREPARE) \
             $(TOOL_BUILD_SEGMENT) \
             $(TOOL_RELEASE) \
             $(TOOL_SIMILARITY) \
             $(TOOL_ASSEMBLER) \
             $(TOOL_ASSEMBLER_Z80)

# List of targets

TARGET_CHR_ORF     = build/chargen_openroms.rom 
TARGET_CHR_PXL     = build/chargen_pxlfont.rom 

TARGET_CUS_B       = build/basic_custom.rom
TARGET_GEN_B       = build/basic_generic.rom
TARGET_GENCRT_B    = build/basic_generic_crt.rom
TARGET_TST_B       = build/basic_testing.rom
TARGET_U64_B       = build/basic_ultimate64.rom
TARGET_U64CRT_B    = build/basic_ultimate64_crt.rom

TARGET_CUS_K       = build/kernal_custom.rom
TARGET_GEN_K       = build/kernal_generic.rom
TARGET_GENCRT_K    = build/kernal_generic_crt.rom
TARGET_TST_K       = build/kernal_testing.rom
TARGET_U64_K       = build/kernal_ultimate64.rom
TARGET_U64CRT_K    = build/kernal_ultimate64_crt.rom

TARGET_GENCRT_X    = build/extrom_generic_crt.crt 
TARGET_U64CRT_X    = build/extrom_ultimate64_crt.crt 

TARGET_M65_x_ORF   = build/mega65_orfont.rom
TARGET_M65_x_PXL   = build/mega65.rom
TARGET_X16_x       = build/cx16-dummy.rom

TARGET_LIST_CUS    = $(TARGET_CUS_B) $(TARGET_CUS_K)
TARGET_LIST_GEN    = $(TARGET_GEN_B) $(TARGET_GEN_K)
TARGET_LIST_GENCRT = $(TARGET_GENCRT_B) $(TARGET_GENCRT_K) $(TARGET_GENCRT_X)
TARGET_LIST_TST    = $(TARGET_TST_B) $(TARGET_TST_K)
TARGET_LIST_U64    = $(TARGET_U64_B) $(TARGET_U64_K)
TARGET_LIST_U64CRT = $(TARGET_U64CRT_B) $(TARGET_U64CRT_K) $(TARGET_U64CRT_X)

TARGET_Z80TEST     = ./build/cpm/Z80TEST.COM

TARGET_LIST        = $(TARGET_CHR_ORF)     \
                     $(TARGET_LIST_CUS)    \
                     $(TARGET_LIST_GEN)    \
                     $(TARGET_LIST_GENCRT) \
                     $(TARGET_LIST_TST)    \
                     $(TARGET_M65_x_ORF)   \
                     $(TARGET_M65_x_PXL)   \
                     $(TARGET_LIST_U64)    \
                     $(TARGET_LIST_U64CRT) \
                     $(TARGET_X16_x)

SEG_LIST_GENCRT    = $(DIR_GENCRT)/basic.seg_1  \
                     $(DIR_GENCRT)/kernal.seg_1

SEG_LIST_U64CRT    = $(DIR_U64CRT)/basic.seg_1  \
                     $(DIR_U64CRT)/kernal.seg_1

SEG_LIST_M65       = $(DIR_M65)/basic.seg_0  \
                     $(DIR_M65)/basic.seg_1  \
                     $(DIR_M65)/kernal.seg_0 \
                     $(DIR_M65)/kernal.seg_C \
                     $(DIR_M65)/kernal.seg_1 \
                     $(DIR_M65)/dos.seg_1    \
                     $(DIR_M65)/mon.seg_1    \
                     $(DIR_M65)/zvm.seg_1

SEG_LIST_X16       = $(DIR_X16)/basic.seg_0  \
                     $(DIR_X16)/basic.seg_1  \
                     $(DIR_X16)/kernal.seg_0 \
                     $(DIR_X16)/kernal.seg_1

REL_TARGET_LIST    = $(TARGET_LIST_GEN)    \
                     $(TARGET_LIST_GENCRT) \
                     $(TARGET_M65_x_ORF)   \
                     $(TARGET_M65_x_PXL)   \
                     $(TARGET_LIST_U64)

# Misc strings

HYBRID_WARNING = "*** WARNING *** Distributing kernal_hybrid.rom violates both original ROM copyright and Open ROMs license!"

# GIT commit

GIT_COMMIT:= $(shell git log -1 --pretty='%h' | tr '[:lower:]' '[:upper:]')

# Rules - main - XXX building ROMs in parallel sometimes fails - most likely due to rules producing multiple targets

.PHONY: all clean updatebin

all:
	@$(MAKE) -s $(DIR_ACME) $(SRC_ACME)
	@$(MAKE) -s -j`nproc` --output-sync=target $(TOOLS_LIST)
	@$(MAKE) -s --output-sync=target $(TARGET_LIST) $(EXT_TARGET_LIST)

clean:
	@rm -rf build src/basic/combined.s src/kernal/combined.s

updatebin:
	@$(MAKE) -s $(DIR_ACME) $(SRC_ACME)
	@$(MAKE) --output-sync=target $(TARGET_LIST) $(TOOL_RELEASE)
	@$(TOOL_RELEASE) -i ./build -o ./bin $(patsubst build/%,%,$(REL_TARGET_LIST))
	@cp build/chargen_openroms.rom bin/chargen_openroms.rom

# Rules - external blobs

$(ROM_CBM_KERNAL):
	@echo
	@echo Please copy \'kernal\' file from the original ROM set to the \'3rdparty/ROMs\' directory
	@echo
	@exit 1

$(ROM_CBM_BASIC):
	@echo
	@echo Please copy \'basic\' file from the original ROM set to the \'3rdparty/ROMs\' directory
	@echo
	@exit 1

# Rules - tools

$(DIR_ACME) $(SRC_ACME) $(DIR_ZMAC) $(SRC_ZMAC) $(SRC_Z80TEST):
	@echo
	@echo Fetching 3rd party source code...
	@git submodule init
	@git submodule update

$(TOOL_ASSEMBLER): $(DIR_ACME) $(SRC_ACME) $(HDR_ACME)
	@echo
	@echo Compiling tool $@ ...
	@mkdir -p build/tools
	@$(CC) -o $(TOOL_ASSEMBLER) $(SRC_ACME) -lm -w -I./3rdparty/acme/src

$(TOOL_PNGPREPARE): tools/pngprepare.c
	@echo
	@echo Compiling tool $@ ...
	@mkdir -p build/tools
	@$(CC) -O2 -Wall -I/usr/local/include -L/usr/local/lib -o $@ $< -lpng

build/tools/%: tools/%.c
	@echo
	@echo Compiling tool $@ ...
	@mkdir -p build/tools
	@$(CC) -O2 -Wall -o $@ $<

build/tools/%: tools/%.cc tools/common.h
	@echo
	@echo Compiling tool $@ ...
	@mkdir -p build/tools
	@$(CXX) -O2 -Wall -o $@ $<

# Rules - CHARGEN

$(TARGET_CHR_ORF): $(TOOL_PNGPREPARE) assets/8x8font.png
	@$(TOOL_PNGPREPARE) charrom assets/8x8font.png $@ 1>/dev/null

$(TARGET_CHR_PXL): bin/chargen_pxlfont_2.3.rom
	@cp $< $@

build/patched_chargen/openroms.pcg: $(TOOL_PATCH_CHARGEN) $(TARGET_CHR_ORF)
	@mkdir -p build/patched_chargen
