=== debian/changelog ===
open-roms (0.0~git20210824.e4e324c-1) unstable; urgency=medium

  * New upstream release.
  * Add upstream metadata.
  * Bump Standards-Version to 4.6.0.

 -- Reiner Herrmann <reiner@reiner-h.de>  Fri, 27 Aug 2021 18:28:59 +0200

open-roms (0.0~git20201206.c33f4af-1) experimental; urgency=medium

  * Initial release. (Closes: #980308)

 -- Reiner Herrmann <reiner@reiner-h.de>  Tue, 19 Jan 2021 00:25:00 +0100
