## open-roms 0.0~git20230727.e41558c

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,8 @@
+
+# Emulator executables
+
+EXEC_X64  = x64sc
+EXEC_X128 = x128
 
 # Test files
 
@@ -187,8 +192,8 @@
 
 # List of targets
 
-TARGET_CHR_ORF     = build/chargen_openroms.rom 
-TARGET_CHR_PXL     = build/chargen_pxlfont.rom 
+TARGET_CHR_ORF     = build/chargen_openroms.rom
+TARGET_CHR_PXL     = build/chargen_pxlfont.rom
 
 TARGET_CUS_B       = build/basic_custom.rom
 TARGET_GEN_B       = build/basic_generic.rom
@@ -204,8 +209,8 @@
 TARGET_U64_K       = build/kernal_ultimate64.rom
 TARGET_U64CRT_K    = build/kernal_ultimate64_crt.rom
 
-TARGET_GENCRT_X    = build/extrom_generic_crt.crt 
-TARGET_U64CRT_X    = build/extrom_ultimate64_crt.crt 
+TARGET_GENCRT_X    = build/extrom_generic_crt.crt
+TARGET_U64CRT_X    = build/extrom_ultimate64_crt.crt
 
 TARGET_M65_x_ORF   = build/mega65_orfont.rom
 TARGET_M65_x_PXL   = build/mega65.rom
@@ -337,5 +342,3 @@
 $(TARGET_CHR_PXL): bin/chargen_pxlfont_2.3.rom
 	@cp $< $@
 
-build/patched_chargen/openroms.pcg: $(TOOL_PATCH_CHARGEN) $(TARGET_CHR_ORF)
-	@mkdir -p build/patched_chargen
