=== debian/changelog ===
open-roms (0.0~git20230727.e41558c-1) unstable; urgency=medium

  * New upstream release.
    - Fix build with GCC 13 (Closes: #1042164)
  * Mark package as Multi-Arch: foreign.

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 27 Jul 2023 19:27:51 +0200

open-roms (0.0~git20230311.8fbcf8a-1) unstable; urgency=medium

  * New upstream snapshot.
  * Bump Standards-Version to 4.6.2.
  * Bump copyright years.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sun, 18 Jun 2023 16:26:42 +0200
