=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Reiner Herrmann <reiner@reiner-h.de>
 Build-Depends: debhelper-compat (= 13), dh-exec, acme, libpng-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/MEGA65/open-roms
 Vcs-Browser: https://salsa.debian.org/reiner/open-roms
 Vcs-Git: https://salsa.debian.org/reiner/open-roms.git
@@ -11,6 +11,7 @@
 
 Package: open-roms
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: ROM files for retro computers
  Using emulators for old retro computers (like the Commodore 64) requires
