=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

ROMS=build/basic_generic.rom build/kernal_generic.rom build/chargen_openroms.rom

%:
	dh $@

override_dh_auto_build:
	ln -sf /usr/bin/acme acme
	dh_auto_build -- TOOL_ASSEMBLER=./acme $(ROMS)

override_dh_auto_test:
	# skip tests as they need to run vice/x64
