## open-roms 0.0~git20250319.46ccd6f

=== Makefile ===
--- 
+++ 
@@ -99,6 +99,14 @@
                  $(DIR_ACME)/dynabuf.c $(DIR_ACME)/mnemo.c $(DIR_ACME)/input.c $(DIR_ACME)/section.c \
                  $(DIR_ACME)/symbol.c $(DIR_ACME)/tree.c
 
+HDR_COMMON     = tools/common.h
+SRC_COMMON     = tools/common.cc
+
+DIR_GENSTR     = tools/generate_strings
+HDR_GENSTR     = $(HDR_COMMON) $(DIR_GENSTR)/dataset.h $(DIR_GENSTR)/dictencoder.h $(DIR_GENSTR)/global.h 
+SRC_GENSTR     = $(SRC_COMMON) $(DIR_GENSTR)/dataset.cc $(DIR_GENSTR)/dictencoder.cc $(DIR_GENSTR)/global.cc \
+                 $(DIR_GENSTR)/main.cc
+
 CRT_BIN_LIST   = assets/cartridge/header-cart.bin \
                  assets/cartridge/header-seg0.bin \
                  assets/cartridge/header-seg1.bin \
@@ -130,7 +138,8 @@
 DIR_CUS        = build/target_custom
 DIR_GEN        = build/target_generic
 DIR_GENCRT     = build/target_generic_crt
-DIR_TST        = build/target_testing
+DIR_TST38      = build/target_testing_38K
+DIR_TST60      = build/target_testing_60K
 DIR_M65        = build/target_mega65
 DIR_U64        = build/target_ultimate64
 DIR_U64CRT     = build/target_ultimate64_crt
@@ -141,7 +150,8 @@
 CFG_CUS        = src/,,config_custom.s 
 CFG_GEN        = src/,,config_generic.s
 CFG_GENCRT     = src/,,config_generic_crt.s
-CFG_TST        = src/,,config_testing.s
+CFG_TST38      = src/,,config_testing_38K.s
+CFG_TST60      = src/,,config_testing_60K.s
 CFG_M65        = src/,,config_mega65.s
 CFG_U64        = src/,,config_ultimate64.s
 CFG_X16        = src/,,config_cx16.s
@@ -152,7 +162,8 @@
 GEN_STR_CUS    = $(DIR_CUS)/,generated/,packed_strings.s
 GEN_STR_GEN    = $(DIR_GEN)/,generated/,packed_strings.s
 GEN_STR_GENCRT = $(DIR_GENCRT)/,generated/,packed_strings.s
-GEN_STR_TST    = $(DIR_TST)/,generated/,packed_strings.s
+GEN_STR_TST38  = $(DIR_TST38)/,generated/,packed_strings.s
+GEN_STR_TST60  = $(DIR_TST60)/,generated/,packed_strings.s
 GEN_STR_M65    = $(DIR_M65)/,generated/,packed_strings.s
 GEN_STR_U64    = $(DIR_U64)/,generated/,packed_strings.s
 GEN_STR_U64CRT = $(DIR_U64CRT)/,generated/,packed_strings.s
@@ -198,14 +209,16 @@
 TARGET_CUS_B       = build/basic_custom.rom
 TARGET_GEN_B       = build/basic_generic.rom
 TARGET_GENCRT_B    = build/basic_generic_crt.rom
-TARGET_TST_B       = build/basic_testing.rom
+TARGET_TST38_B     = build/basic_testing_38K.rom
+TARGET_TST60_B     = build/basic_testing_60K.rom
 TARGET_U64_B       = build/basic_ultimate64.rom
 TARGET_U64CRT_B    = build/basic_ultimate64_crt.rom
 
 TARGET_CUS_K       = build/kernal_custom.rom
 TARGET_GEN_K       = build/kernal_generic.rom
 TARGET_GENCRT_K    = build/kernal_generic_crt.rom
-TARGET_TST_K       = build/kernal_testing.rom
+TARGET_TST38_K     = build/kernal_testing_38K.rom
+TARGET_TST60_K     = build/kernal_testing_60K.rom
 TARGET_U64_K       = build/kernal_ultimate64.rom
 TARGET_U64CRT_K    = build/kernal_ultimate64_crt.rom
 
@@ -219,7 +232,8 @@
 TARGET_LIST_CUS    = $(TARGET_CUS_B) $(TARGET_CUS_K)
 TARGET_LIST_GEN    = $(TARGET_GEN_B) $(TARGET_GEN_K)
 TARGET_LIST_GENCRT = $(TARGET_GENCRT_B) $(TARGET_GENCRT_K) $(TARGET_GENCRT_X)
-TARGET_LIST_TST    = $(TARGET_TST_B) $(TARGET_TST_K)
+TARGET_LIST_TST38  = $(TARGET_TST38_B) $(TARGET_TST38_K)
+TARGET_LIST_TST60  = $(TARGET_TST60_B) $(TARGET_TST60_K)
 TARGET_LIST_U64    = $(TARGET_U64_B) $(TARGET_U64_K)
 TARGET_LIST_U64CRT = $(TARGET_U64CRT_B) $(TARGET_U64CRT_K) $(TARGET_U64CRT_X)
 
@@ -229,7 +243,8 @@
                      $(TARGET_LIST_CUS)    \
                      $(TARGET_LIST_GEN)    \
                      $(TARGET_LIST_GENCRT) \
-                     $(TARGET_LIST_TST)    \
+                     $(TARGET_LIST_TST38)  \
+                     $(TARGET_LIST_TST60)  \
                      $(TARGET_M65_x_ORF)   \
                      $(TARGET_M65_x_PXL)   \
                      $(TARGET_LIST_U64)    \
@@ -314,31 +329,3 @@
 	@echo
 	@echo Compiling tool $@ ...
 	@mkdir -p build/tools
-	@$(CC) -o $(TOOL_ASSEMBLER) $(SRC_ACME) -lm -w -I./3rdparty/acme/src
-
-$(TOOL_PNGPREPARE): tools/pngprepare.c
-	@echo
-	@echo Compiling tool $@ ...
-	@mkdir -p build/tools
-	@$(CC) -O2 -Wall -I/usr/local/include -L/usr/local/lib -o $@ $< -lpng
-
-build/tools/%: tools/%.c
-	@echo
-	@echo Compiling tool $@ ...
-	@mkdir -p build/tools
-	@$(CC) -O2 -Wall -o $@ $<
-
-build/tools/%: tools/%.cc tools/common.h
-	@echo
-	@echo Compiling tool $@ ...
-	@mkdir -p build/tools
-	@$(CXX) -O2 -Wall -o $@ $<
-
-# Rules - CHARGEN
-
-$(TARGET_CHR_ORF): $(TOOL_PNGPREPARE) assets/8x8font.png
-	@$(TOOL_PNGPREPARE) charrom assets/8x8font.png $@ 1>/dev/null
-
-$(TARGET_CHR_PXL): bin/chargen_pxlfont_2.3.rom
-	@cp $< $@
-
