=== debian/changelog ===
open-roms (0.0~git20250319.46ccd6f-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sat, 22 Mar 2025 15:46:46 +0100
