=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Reiner Herrmann <reiner@reiner-h.de>
 Build-Depends: debhelper-compat (= 13), dh-exec, acme, libpng-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/MEGA65/open-roms
 Vcs-Browser: https://salsa.debian.org/reiner/open-roms
 Vcs-Git: https://salsa.debian.org/reiner/open-roms.git
