=== debian/watch ===
version=4
opts="mode=git" \
https://github.com/MEGA65/open-roms.git HEAD
